package Kindergarten;
import java.util.*;

/**
 * Az egyik osztlyunk, ami a {@link KozosOs}bl szrmazik.&nbsp;Fontos szerepe lesz a jtk folyamn, az {@link Ovono}t tudja feltlteni csokival, illetve az {@link Ovodas}t tudja elbmszkodtatni.
 *
 * @author  InFoka
 * @version %I%, %G%
 */
public class Csokiautomata extends KozosOs {
	public static int csokiautomatakszama=0;
	private int sid;

   /**
    * A konstruktor, egyelre semmi szerepe.
	*/
	public Csokiautomata() {
		sid=csokiautomatakszama++;
		proto.Log("Csokiautomata["+sid+"]::Letrehozva");
	}

   /**
    * Amikor az {@link Ovono} olyan {@link PalyaElem}re lep, ahol talalhato {@link Csokiautomata}, akkor ez a fggvny hvdik meg, s feltlti az {@link Ovono}t csokival, annak CsokiFeltolt fggvnynek meghvsval.
	*
	* @param ovono	az {@link Ovono}re mutat referencia, amivel elrhetjk az {@link Ovono} CsokivalFeltolt fggvnyt
	*/
    public void OvonoUdvozol(Ovono ovono) {
		proto.Log("Csokiautomata["+sid+"]::Ovono udvozolt");
		ovono.CsokivalFeltolt();
    }
    
   /**
    * Amikor az {@link Ovodas} olyan {@link PalyaElem}re lep, ahol talalhato {@link Csokiautomata}, akkor ez a fggvny hvdik meg, s elbmszkodtatja az {@link Ovodas}t, annak Bameszkodik fggvnynek meghvsval.
	*
	* @param ovis	az {@link Ovodas}ra mutat referencia, amivel elrhetjk az {@link Ovodas} Bameszkodik fggvnyt
	*/
    public void OvodasUdvozol(Ovodas ovis) {
		proto.Log("Csokiautomata["+sid+"]::Ovodas udvozolt");
		ovis.CsokiautomataUdvozol();
    }

   /**
    * Az AktHelyzet vltozt hivatott belltani.
	*/
	public void AktHelyzetBeallit(PalyaElem akt) {
		if(akt==null) { 
			proto.Kiir("Hiba: Csokiautomata["+sid+"]::AktHelyzet-et nem lehet beallitani, parameter erteke null");
			proto.Kiir("Hiba:                   A teszteles idejere uj PalyaElemet hozok letre");
			AktHelyzet=new PalyaElem();
		}
		else AktHelyzet=akt;
		proto.Log("Csokiautomata["+sid+"]::AktHelyzet beallitva");
		AktHelyzet.Atvesz(this);
	}

	public char getFaj() { return 'C'; }
}
