package Kindergarten;
import java.util.*;

/**
 * A mozg objektumok x,y helyzett fogja trolni.
 *
 * @author  InFoka
 * @version %I%, %G%
 */
public class GPS {
	int FromX;
	int FromY;
	int ToX;
	int ToY;
	int Speed;
	final int RunSpeed=5;
	final int FollowSpeed=3;
	final int WalkSpeed=1;
	

   /**
	* A konstruktor, ami belltja az osztlyvltozkat, a sebessget jelenleg 2-re.
	*/
	public GPS(KozosOs master) {
		FromX=FromY=ToX=ToY=-1;
		if(master.getFaj()=='O') Speed=FollowSpeed; else Speed=WalkSpeed;
	}
   /**
	* A fggvny kiszmolja a kvetkez aktulis pozcit a cl fel, s belltja a From[X|Y] vltozkat.
	*/
	public void calcFrom() { 
		if (FromX>ToX) {										// Ilyenkor balra kell menni.
			if(FromX-ToX>Speed) FromX-=Speed; else FromX=ToX;	// Hogy biztosan megrkezznk a kvnt helyre, s ne lpjnk tl rajta szksg van egy ellenrzsre.
		} else if(FromX==ToX) {									// Ilyenkor fgglegesen kell haladni.
			// Ekkor az X tengelyen nem trtnik vltozs.
		} else {												// Ilyenkor jobbra kell menni.
			if(ToX-FromX>Speed) FromX+=Speed; else FromX=ToX;	// Hogy biztosan megrkezznk a kvnt helyre, s ne lpjnk tl rajta szksg van egy ellenrzsre.
		}
		if (FromY>ToY) {										// Ilyenkor le kell menni.
			if(FromY-ToY>Speed) FromY-=Speed; else FromY=ToY;	// Hogy biztosan megrkezznk a kvnt helyre, s ne lpjnk tl rajta szksg van egy ellenrzsre.
		} else if(FromY==ToY) {									// Ilyenkor vzszintesen kell haladni.
			// Ekkor az Y tengelyen nem trtnik vltozs.
		} else {												// Ilyenkor fel kell menni.
			if(ToY-FromY>Speed) FromY+=Speed; else FromY=ToY;	// Hogy biztosan megrkezznk a kvnt helyre, s ne lpjnk tl rajta szksg van egy ellenrzsre.
		}
	}
   /**
	* A fggvny belltja az j To[X|Y] vltozkat, majd amennyiben az aktulis helyzet (From[X|Y]) nem egyezik vele, akkor szmtst kr az j pozci ltrehozsra.
	*
	* @param	a	az x koordinta rtke
	* @param	b	az y koordinta rtke
	*/
	public void setTo(int a, int b) { 
		if(ToY==-1&&FromY==-1) { 
			FromX=a; 
			FromY=b; 
		}
		ToX=a; 
		ToY=b; 
		calcFrom();
	}
   /**
	* A fggvny visszaadja az aktulis helyzetet egy ktelem Integer tmbben.
	*
	* @return	int[]	az aktulis helyzet koordintit adja vissza (From[X|Y])
	*/
	public int[] GPSinfo() { int[] tmp = new int[2]; tmp[0]=FromX; tmp[1]=FromY; return tmp; }

   /**
    * Megtudhatjuk, hogy az objektum ppen mozog vagy sem. Amennyiben a from s to paramterek megyeznek false-al tr vissza, egybknt true-val.
	* @return	boolean	mozog akkor true, ha nem false
	*/
	public boolean isMoving() { return (!(FromX==ToX&&FromY==ToY)); }

	public void SpeedFOLLOW() { if(Speed!=FollowSpeed) Speed=FollowSpeed; }

	public void SpeedWALK() { if(Speed!=WalkSpeed) Speed=WalkSpeed; }

	public void SpeedRUN() { if(Speed!=RunSpeed) Speed=RunSpeed; }

	public void SpeedSTOP() { if(Speed!=0) Speed=0; }

	public int getY() { return FromY; }
}