package Kindergarten;

import java.awt.event.*;
import java.awt.image.BufferedImage;
import java.util.*;
import java.awt.*;
import java.io.File;

/**
 * A grafikai megjelentsrt felels osztly.
 * @author  InFoka
 * @version %I%, %G%
 */
public class Grafika extends Frame {
	
	/**
	 * A megjelentsi rteg alapja, a kezdeti kp kirajzolsa utn bizonyos idkznknt 
	 * lekri a kirajzoland objektumok llapotvektorait. Ezt rtelmezve frissti a kpernyt.
	 * A rajzolst a memriban lev Graphics objektumra vgzi, majd a ciklus vgn az egszet
	 *  kirajzolja a kpernyre. 
	 */
	class Idozito extends Thread
	{
		Palya palya;
		Proto proto;
		BufferedImage puffer,alap;
		Graphics g,ga;
		Image kepek[];
		
		public Idozito(Palya p)
		{
			proto=new Proto();
			palya=p;
			puffer=new BufferedImage(600,645,BufferedImage.TYPE_INT_RGB);
			alap=new BufferedImage(600,645,BufferedImage.TYPE_INT_RGB);
			ga=alap.getGraphics();
			g=puffer.getGraphics();
			kepek=new Image[100];
			KepekBetolt();
		}
		
		/**
		 * A kisebb ksleltets miatt az sszes hasznlt kpet egy tmbben troljuk.
		 * indulskor ezt a tmbt a megfelel kpekkel ez a metdus tlti fel.
		 */
		public void KepekBetolt()
		{
			String sep=File.separator;
			int azonosito=0;	// Plya kpe
			kepek[azonosito*10+0]=Toolkit.getDefaultToolkit().getImage("grafika"+sep+"palya_0.jpg");
			kepek[azonosito*10+1]=Toolkit.getDefaultToolkit().getImage("grafika"+sep+"palya_1.jpg");
			kepek[azonosito*10+2]=Toolkit.getDefaultToolkit().getImage("grafika"+sep+"palya_2.jpg");
			
			azonosito=1;		// Egy llapot kpek
			kepek[azonosito*10+0]=Toolkit.getDefaultToolkit().getImage("grafika"+sep+"ovoda.gif");	// Ovoda
			kepek[azonosito*10+1]=Toolkit.getDefaultToolkit().getImage("grafika"+sep+"csokiautomata.gif");	// Csokiautomata
			kepek[azonosito*10+3]=Toolkit.getDefaultToolkit().getImage("grafika"+sep+"jatekbolt.gif");	// Jtkbolt

			azonosito=2;		// Ovono
			kepek[azonosito*10+0]=Toolkit.getDefaultToolkit().getImage("grafika"+sep+"ovono_0.gif");	
			kepek[azonosito*10+1]=Toolkit.getDefaultToolkit().getImage("grafika"+sep+"ovono_1.gif");	
			kepek[azonosito*10+2]=Toolkit.getDefaultToolkit().getImage("grafika"+sep+"ovono_2.gif");	
			kepek[azonosito*10+3]=Toolkit.getDefaultToolkit().getImage("grafika"+sep+"ovono_3.gif");	
			kepek[azonosito*10+4]=Toolkit.getDefaultToolkit().getImage("grafika"+sep+"ovono_4.gif");	
			kepek[azonosito*10+5]=Toolkit.getDefaultToolkit().getImage("grafika"+sep+"ovono_5.gif");	

			azonosito=3;		// Fiuovis
			kepek[azonosito*10+0]=Toolkit.getDefaultToolkit().getImage("grafika"+sep+"fiuovis_0.gif");	
			kepek[azonosito*10+1]=Toolkit.getDefaultToolkit().getImage("grafika"+sep+"fiuovis_1.gif");	
			kepek[azonosito*10+2]=Toolkit.getDefaultToolkit().getImage("grafika"+sep+"fiuovis_2.gif");	
			kepek[azonosito*10+3]=Toolkit.getDefaultToolkit().getImage("grafika"+sep+"fiuovis_3.gif");	
			kepek[azonosito*10+4]=Toolkit.getDefaultToolkit().getImage("grafika"+sep+"fiuovis_4.gif");	
			kepek[azonosito*10+5]=Toolkit.getDefaultToolkit().getImage("grafika"+sep+"fiuovis_5.gif");

			azonosito=4;		// Lanyovis
			kepek[azonosito*10+0]=Toolkit.getDefaultToolkit().getImage("grafika"+sep+"lanyovis_0.gif");	
			kepek[azonosito*10+1]=Toolkit.getDefaultToolkit().getImage("grafika"+sep+"lanyovis_1.gif");	
			kepek[azonosito*10+2]=Toolkit.getDefaultToolkit().getImage("grafika"+sep+"lanyovis_2.gif");	
			kepek[azonosito*10+3]=Toolkit.getDefaultToolkit().getImage("grafika"+sep+"lanyovis_3.gif");	
			kepek[azonosito*10+4]=Toolkit.getDefaultToolkit().getImage("grafika"+sep+"lanyovis_4.gif");	
			kepek[azonosito*10+5]=Toolkit.getDefaultToolkit().getImage("grafika"+sep+"lanyovis_5.gif");

			azonosito=5;		// Kutya
			kepek[azonosito*10+0]=Toolkit.getDefaultToolkit().getImage("grafika"+sep+"kutya_0.gif");	
			kepek[azonosito*10+1]=Toolkit.getDefaultToolkit().getImage("grafika"+sep+"kutya_1.gif");	
			kepek[azonosito*10+2]=Toolkit.getDefaultToolkit().getImage("grafika"+sep+"kutya_2.gif");	
			kepek[azonosito*10+3]=Toolkit.getDefaultToolkit().getImage("grafika"+sep+"kutya_3.gif");	
			kepek[azonosito*10+4]=Toolkit.getDefaultToolkit().getImage("grafika"+sep+"kutya_4.gif");	
			kepek[azonosito*10+5]=Toolkit.getDefaultToolkit().getImage("grafika"+sep+"kutya_5.gif");
		}

		/**
		 * A plyn lland jelleggel rajtalv rajzok kirajzolsst vgzi.
		 *
		 */
		public void statikuskep() {
			ga.drawImage(kepek[proto.getSzint()],0,0,600,600,null);
		}

		/**
		 * Kirajzolja a plyaelemeken lv objektumokat
		 *
		 * magassg: 5  / \
		 * magassg: 20 | | szlessg: 30
		 * magassg: 5  \ /
		 */
		public void Kirajzol() {
			Vector PalyaElemek=palya.getPE();
			Vector Objektumok;
			int [] so;
			for(int i=0;i<PalyaElemek.size();i++) {
				Objektumok=((PalyaElem)PalyaElemek.get(i)).LekerdezObjektumok();
				so=getSO(i);
				for(int j=0;j<Objektumok.size();j++) {
					if((Objektumok.get(j))!=null) {
						int x,y;
						x=(so[0]%2==0?0:15)+so[1]*30;
						y=so[0]*29;
						switch(j) {
							case 0: break;
							case 1: x-=5; break;
							case 2: y-=5; break;
							case 3: x+=5; break;
							case 4: y+=5; break;
							default: {
								if(Math.random()<=0.5) x+=((int)(Math.random()*5)); else x-=((int)(Math.random()*5));
								if(Math.random()>=0.5) y+=((int)(Math.random()*5)); else y-=((int)(Math.random()*5));
								break;
							}
						}
						int[] c = new int[2];
						KozosOs kos = (KozosOs)Objektumok.get(j);
						int irany = kos.getIranyom();
						switch(kos.getFaj()) {
							case 'O' : {
								c=kos.Menj(x,y);	
								g.drawImage(kepek[20+irany],c[0],c[1],null);	
								Ovodas ovis=((Ovono)kos).getElsoOvodas();
								if(ovis!=null) {
									int [] from = new int[2];
									int [] to = new int[2];
									from=kos.gps.GPSinfo();
									to=ovis.gps.GPSinfo();
									if(ovis.getFaj()=='L') g.setColor(Color.MAGENTA); else g.setColor(Color.BLUE);
									g.drawLine(from[0]+10,from[1]+10,to[0]+10,to[1]+10);
								}
								break;
							}
							case 'F' : {
								c=kos.Menj(x,y);	
								g.drawImage(kepek[30+irany],c[0],c[1],null);
								Ovodas ovis=((Ovodas)kos);
								if(ovis.Utana!=null) {
									int [] from = new int[2];
									int [] to = new int[2];
									from=ovis.gps.GPSinfo();
									to=ovis.Utana.gps.GPSinfo();
									g.setColor(Color.BLUE);
									g.drawLine(from[0]+10,from[1]+10,to[0]+10,to[1]+10);
								}
								break;
							}
							case 'C' :					g.drawImage(kepek[11],x,y,null);				break;
							case 'K' : c=kos.Menj(x,y);	g.drawImage(kepek[50+irany],c[0],c[1],null);	break;
							case 'S' :					g.drawImage(kepek[10],x-10,y,null);				break; // Kicsit balra behzom az vodt, hogy szpen ltszon.
							case 'J' :					g.drawImage(kepek[13],x,y,null);				break;
							case 'L' : {
								c=kos.Menj(x,y);	
								g.drawImage(kepek[40+irany],c[0],c[1],null);
								Ovodas ovis=((Ovodas)kos);
								if(ovis.Utana!=null) {
									int [] from = new int[2];
									int [] to = new int[2];
									from=ovis.gps.GPSinfo();
									to=ovis.Utana.gps.GPSinfo();
									g.setColor(Color.MAGENTA);
									g.drawLine(from[0]+10,from[1]+10,to[0]+10,to[1]+10);
								}
								break;
							}
							default : break;
						}
					}
				}
			}
		}
	
		
		/**
		 * Adott idkznknt kirajzolja a plyt. Meghvja a frisst metdusokat.
		 */
		public void run()
		{
			try
			{
				int itmp=0;
				while (true)
				{
					if(itmp<50)
					{
						statikuskep();
						itmp++;
					}
					
					sleep(30);
					Graphics gPanel=p.getGraphics();
					g.drawImage(alap,0,0,null);
										
					Kirajzol();
					
					gPanel.drawImage(puffer,0,0,null);
					if(proto.getPalya().ovono.CsokiSzamLekerdez()==0) l.setForeground(Color.RED); else l.setForeground(Color.WHITE);
					l.setText("Htralev id: "+(proto.getIdo()).IdotLekerdez()+" msodperc   Pontszmod: "+(proto.getSzamlalo()).EredmenytLekerdez()+"    Csokiszmod: "+proto.getPalya().ovono.CsokiSzamLekerdez());
				}
			}catch (InterruptedException E){return;}
					
		}
	}

    Panel p;
	Label l;
	Idozito i;
	Proto proto;

    MenuBar menusor;
    Menu jatek;
    MenuItem ujjatek;
    MenuItem ujrakezd;
    MenuItem legjobbak;
    MenuItem kilepes;
	Image ws;
	WelcomeScreen wsth;

    Jatek j; 	
	static int gomb=0;
    
    /**
     * Ltrehozza az ablakot, a menket s minden grafikus objektumot.
     * @param ja - a Jatek objektum azaonostja.
     */
	public Grafika()
	{
		super("InFoka - Kindergarten");
		proto = new Proto();
		j=proto.getJatek();
		setSize(600,645);
		setLocation(200,80);
        addWindowListener(new WindowAdapter() { 
                public void windowClosing(WindowEvent we)
                        { System.exit(-1);}});
        p=new Panel();
        p.setBackground(Color.BLACK);
        
        l=new Label("");
        l.setBackground(Color.BLACK);
		l.setForeground(Color.WHITE);
        l.setText("");
        l.setVisible(false);
        setLayout(new BorderLayout());
        add(p,BorderLayout.CENTER);
        add(l,BorderLayout.NORTH);
        
        menusor=new MenuBar();
        jatek=new Menu("Jtk");
        ujjatek=new MenuItem("j jtk...");
        ujrakezd=new MenuItem("Szint jrakezdse");
        ujrakezd.setEnabled(false);
        legjobbak=new MenuItem("Legjobbak");
        kilepes=new MenuItem("Kilps");
        menusor.add(jatek);
        jatek.add(ujjatek);
        jatek.add(ujrakezd);
        jatek.add(legjobbak);
        jatek.add(kilepes);
        setMenuBar(menusor);

        kilepes.addActionListener(new ActionAdapter() {
	    	public void actionPerformed(ActionEvent e) {
	    		System.exit(-1);
	    	}
        });
        ujjatek.addActionListener(new ActionAdapter() {
	    	public void actionPerformed(ActionEvent e) {
	    		j.JatekIndit();
	            ujrakezd.setEnabled(true);
	    	}
        });
        ujrakezd.addActionListener(new ActionAdapter() {
	    	public void actionPerformed(ActionEvent e) {
				Palya palya = proto.getPalya();
	    		palya.Nullaz(); palya.ido.rst(); palya.PalyaEpit(); proto.Engedelyez();
	    	}
        });
        legjobbak.addActionListener(new ActionAdapter() {
	   		public void actionPerformed(ActionEvent e) {
	   			proto.Tilt();
	   			LegjobbakAblak tmp=new LegjobbakAblak(j,false);
	    		proto.Engedelyez();
	    	}
        });
        p.addKeyListener(new KeyAdapter() {
        	public void keyPressed(KeyEvent e) {
        		switch(e.getKeyCode()) {
					/* Elvileg elsdleges irnyts */
					case KeyEvent.VK_LEFT: {
						if(gomb==0) proto.getPalya().ovono.Mozog(0); 
						else if(gomb==1) { proto.getPalya().ovono.Mozog(1); gomb=0; }
						else { proto.getPalya().ovono.Mozog(5); gomb=0; }
						break;
					}
					case KeyEvent.VK_UP: gomb=1; break;
					case KeyEvent.VK_DOWN: gomb=2; break;
					case KeyEvent.VK_RIGHT: {
						if(gomb==0) proto.getPalya().ovono.Mozog(3); 
						else if(gomb==1) { proto.getPalya().ovono.Mozog(2); gomb=0; }
						else { proto.getPalya().ovono.Mozog(4); gomb=0; }
						break;
					}
					/* Msodlagos irnyts */
					case KeyEvent.VK_NUMPAD7: proto.getPalya().ovono.Mozog(1); break;
					case KeyEvent.VK_NUMPAD4: proto.getPalya().ovono.Mozog(0); break;
					case KeyEvent.VK_NUMPAD1: proto.getPalya().ovono.Mozog(5); break;
					case KeyEvent.VK_NUMPAD9: proto.getPalya().ovono.Mozog(2); break;
					case KeyEvent.VK_NUMPAD6: proto.getPalya().ovono.Mozog(3); break;
					case KeyEvent.VK_NUMPAD3: proto.getPalya().ovono.Mozog(4); break;
					/* Gyakorlatilag elsdleges irnyts */
					case KeyEvent.VK_Q: proto.getPalya().ovono.Mozog(1); break;
					case KeyEvent.VK_A: proto.getPalya().ovono.Mozog(0); break;
					case KeyEvent.VK_Y: proto.getPalya().ovono.Mozog(5); break;
					case KeyEvent.VK_E: proto.getPalya().ovono.Mozog(2); break;
					case KeyEvent.VK_D: proto.getPalya().ovono.Mozog(3); break;
					case KeyEvent.VK_C: proto.getPalya().ovono.Mozog(4); break;
					default: break;
				}
        	}
        });
        
		setVisible(true);
		ws=Toolkit.getDefaultToolkit().getImage("grafika\\ws.jpg");
		wsth=new WelcomeScreen();
		wsth.start();
	}
	/**
	 * Osztly, mely frissti az dvzlkpernyt, ha azt vmilyen ablak eltakarn.
	 * @author Urbi
	 *
	 * TODO To change the template for this generated type comment go to
	 * Window - Preferences - Java - Code Style - Code Templates
	 */
	class WelcomeScreen extends Thread
	{
		public void run()
		{
			while(true)
			{
				try
				{
					sleep(30);
					(p.getGraphics()).drawImage(ws,0,0,null);
				}catch(Exception E){return;}
			}
		}
	}
	
	/**
	 * Lelltja az elz folyamatot s j frisst szlat indt, 
	 * kirajzolja az j plyt s indul a jtk.
	 * @param p
	 */
	public void setPalya(Palya p)
	{
		if (wsth!=null) wsth.interrupt();
		l.setVisible(true);
		setSize(600,645);
		if (i!=null) i.interrupt();
        i=new Idozito(p);
        i.start();
        setVisible(true);
	}
	
	/**
	 * Nv bekrse
	 * @param jatek
	 */
	public void BekerNev(Jatek jatek)
	{
		Beker tmp=new Beker(jatek);
	}

   /**
    * A PalyaElem id-je alapjn visszadja, hogy melyik sorban s melyik oszlopban tallhat, a grafikus rszben ebbl szmtdik, hogy a rajta lv objektum hova kerljn a kpen, teht fontos, hogy jl mkdjn!
	* @return int[]	a sor s oszlop rtkt adja vissza
	*/
	public int[] getSO(int id) {
		int [] so = new int[2];
		int Sorhossz = proto.getPalya().getSorhossz();
		int sor, oszlop, mod, ds, div;
		ds=2*Sorhossz-1;						// Egy duplasor mrete.
		mod=id%ds;								// Az id s a duplasor maradka.
		div=(id-mod)/ds;						// Az id egszosztsa a duplasorral.
		sor=div*2;								// A sorok elzetes vagy vgleges szma.
		oszlop=mod;								// Az oszlopok elzetes szma.
		if(mod>=Sorhossz) {
			sor++;								// A sorok vgleges szma mindenkpp.
			oszlop-=Sorhossz;					// Az oszlopok vgleges szma mindenkpp.			
		}
		so[0]=sor;
		so[1]=oszlop;
		return so;
	}
}