package Kindergarten;
import java.util.*;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.io.StreamTokenizer;

/**  
 * A java.util.LinkedList osztly az sosztlya.&nbsp; A {@link Toplista} osztly hasznlja.
 * Ez az osztly fogja trolni a felhasznlk ltal elrt eredmnyeket, egy-egy {@link ListaElem}ben.
 *
 * @author   InFoka
 * @version  %I%, %G%
 */
public class Lista extends LinkedList {
	public Proto proto;

   /**
    * A konstruktor, amely egyelre egy Proto pldnyt hoz ltre sajt magnak,
	* a ksbbiekben klnsebb feladata nem lesz.
	*/
	public Lista() {
		proto = new Proto();
		proto.Log("Lista::Letrehozva");
		BufferedReader lf;
		StreamTokenizer token;
		try {
			lf = new BufferedReader(new InputStreamReader(new FileInputStream(new File("toplista"))));
			token=new StreamTokenizer(lf);
			token.wordChars(' ','z');
			token.whitespaceChars('\n','\n');
			for(int i=0;i<=9;i++)
			{
				token.nextToken();
				String nev=token.sval;
				token.nextToken();
				int eredmeny=(int)token.nval;
				token.nextToken();
				int szint=(int)token.nval;
				if (nev!=null) beszur(nev,eredmeny,szint);
			}
		}
		catch (FileNotFoundException e) {
			System.out.println("Nincs meg a fajl: toplista");
			System.exit(-1);
		}
		catch (IOException e) {
			System.out.println("Jatekban hiba olvasas kzben");
			System.exit(-1);
		}
	}
   /**
    * A jtk vgn a felhasznl ltal elrt eredmnyt ezzel a fggvnnyel menthetjk el.
	* Az adatokat, amit paramterek kzt kap, egy j {@link ListaElem}be teszi, 
	* majd hozz is adja a listhoz, az sosztlybl rklt add(Object o) fggvnnyel.
	* Utoljra pedig meghvja a rendez() fggvnyt, ami az j {@link ListaElem}mel bvlt listt rendezi eredmnyek, s szint szerint.
	*
	* @param nev		a felhasznl neve, amit a jtk elejn megadott
	* @param eredmeny	a felhasznl ltal sszeszedett vodsok szma
	* @param szint		a felhasznl ltal teljestett szint, amely a kvetkez lehet:
	*					<ul>
	*					<li>1 - Knny
	*					<li>2 - Kzepes
	*					<li>3 - Nehz
    */
	public void beszur(String nev, int eredmeny, int szint) {
		add(new ListaElem(szint,nev,eredmeny));
		proto.Log("Lista::Uj elem felveve");
		rendez();
	}

   /**
    * A beszur fggvny hvja meg, az egsz listt rendezi az eredmnyek, s szint szerint.
	*/
	public void rendez() {
		for(int i=0;i<size()-1;i++)
			for(int k=0;k<size()-1;k++) {
				ListaElem x,y;
				x=((ListaElem)get(k));
				y=((ListaElem)get(k+1));
				if(x.pont<y.pont) {
					set(k,y);
					set(k+1,x);
				}
			}					
		proto.Log("Lista::Rendezve");
	}

	public void kiir() {
		ListaElem t;
		for(int i=0;i<size();i++) {
			t=(ListaElem)get(i);
			proto.Kiir("Lista::Eredmenyek -> "+(i+1)+". "+t.nev+"\t P: "+t.pont+" Sz: "+t.szint);
			proto.Log("Lista::Eredmenyek -> "+(i+1)+". "+t.nev+"\t P: "+t.pont+" Sz: "+t.szint);
		}
		PrintWriter lf;
		try {
				lf = new PrintWriter( new BufferedWriter(new FileWriter("toplista")));
				for(int i=0;i<(size()>10?10:size());i++) {
					if(((ListaElem)get(i))!=null) {
						lf.println(((ListaElem)get(i)).nev);
						lf.flush();
						lf.println(((ListaElem)get(i)).pont);
						lf.flush();
						lf.println(((ListaElem)get(i)).szint);
						lf.flush();
					}
				}
				lf.close();
		} catch (IOException e) {}
	}

	public ListaElem[] Legjobbak() {
		ListaElem [] t=new ListaElem[10];
		for(int i=0;i<(size()<=10?size():10);i++) {
			t[i]=(ListaElem)get(i);
		}
		rendez();
		kiir();
		return t;
	}

   /**  
	* A {@link Lista} osztly hasznlja, annak bels osztlya.
	* Ez az osztly fogja trolni a felhasznlk ltal elrt eredmnyeket.
	*
	* @author  InFoka
	* @version %I%, %G%
	*/
	public class ListaElem {
		public int szint, pont;
		public String nev;
	   /**
	    * A konstruktor.&nbsp;Belltja az osztlyvltozkat, a paramterknt kapott adatokkal.
		* Az adatokat a {@link Lista} beszur fggvnyn t kapja (bvebb lerst lsd ott).
		*
		* @param s	a felhasznl ltal, a jtk elejn vlasztott szintje
		* @param n	a felhasznl neve
		* @param p	a felhasznl eredmnye (pontjainak szma)
		*/
		public ListaElem(int s, String n, int p) {
			szint=s;
			nev=n;
			pont=p;
		}
	}
}
