package Kindergarten;
import java.util.*;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

/**
 * A {@link Jatek} osztly fogja ltrehozni egy pldnyban, s feladata a jtk indtsa.
 * A felhasznl miutn kivlasztotta a nehzsget, lefut a 3 kzl az egyik nehzsgi fggvny, mely ltrehozza a {@link Palya} objektumot, s belltja a szksgeseket, s meghvja a plyaptst.
 *
 * @author  InFoka
 * @version %I%, %G%
 */
public class Nehezseg extends Dialog {
	Button konnyu, kozepes, nehez;
	public Proto proto;

   /**
    * A konstruktor, ami egyenlre alaprtelmezsben a Konnyu() szintet futtatja, a kzeljvben kicsit komplexebben fog mkdni.
	*/
	public Nehezseg(Jatek j) {
		super(j.gr,"Kindergarten - Vlassz szintet!",true);
		proto = new Proto();
		proto.Log("Nehezseg::Letrehozva");
		konnyu=new Button("Knny");
		kozepes=new Button("Kzepes");
		nehez=new Button("Nehz");
        setBackground(Color.BLACK);
        setSize(225,70);
        setLocation(300,250);
        setLayout(new BorderLayout());
        add(konnyu,BorderLayout.WEST);
        add(kozepes,BorderLayout.CENTER);
		add(nehez,BorderLayout.EAST);
        addWindowListener(new WindowAdapter() { public void windowClosing(WindowEvent we) { hide(); }});
        konnyu.addActionListener(new ActionAdapter() { public void actionPerformed(ActionEvent e) { proto.setSzint(0); Konnyu(); hide(); }});
        kozepes.addActionListener(new ActionAdapter() { public void actionPerformed(ActionEvent e) { proto.setSzint(1); Kozepes(); hide(); }});
        nehez.addActionListener(new ActionAdapter() { public void actionPerformed(ActionEvent e) { proto.setSzint(2); Nehez(); hide(); }});
        show();		
	}

    
   /**
    * A nehzsgi szint fggvnye kzl a Knny szintet reprezentl.
	* Ltrehoz egy {@link Palya} objektumot, majd ennek maximlis rtkeit belltja, s meghvja a plyapts fggvnyt.
	*/
    public void Konnyu() {
		proto.Log("Nehezseg::Konnyu szint inditasa");
		Palya palya = new Palya();
		palya.OsszOvodasBeallit(16);
		palya.OsszJatekboltBeallit(2);
		palya.OsszCsokiautomataBeallit(3);
		palya.OsszKutyaBeallit(1);
		palya.PalyaEpit();
		proto.Engedelyez();
		proto.getJatek().gr.setPalya(palya);
    }
    
   /**
    * A nehzsgi szint fggvnyek kzl a Kzepes szintet reprezentl.&nbsp;(Bvebben lsd Konnyu()-nl.)
	*/
    public void Kozepes() {
		proto.Log("Nehezseg::Kozepes szint inditasa");
		Palya palya = new Palya();
		palya.OsszOvodasBeallit(16);
		palya.OsszJatekboltBeallit(4);
		palya.OsszCsokiautomataBeallit(2);
		palya.OsszKutyaBeallit(2);
		palya.PalyaEpit();
		proto.Engedelyez();
		proto.getJatek().gr.setPalya(palya);
    }
    
   /**
    * A nehzsgi szint fggvnyek kzl a Nehz szintet reprezentl.&nbsp;(Bvebben lsd Konnyu()-nl.)
	*/
    public void Nehez() {
		proto.Log("Nehezseg::Nehez szint inditasa");
		Palya palya = new Palya();
		palya.OsszOvodasBeallit(16);
		palya.OsszJatekboltBeallit(6);
		palya.OsszCsokiautomataBeallit(1);
		palya.OsszKutyaBeallit(3);
		palya.PalyaEpit();
		proto.Engedelyez();
		proto.getJatek().gr.setPalya(palya);
    }
}