package Kindergarten;
import java.util.*;

/**
 * Az egyik megjelentett objektum, a kperny egyik sarka krl lesz jelen, az {@link Ovono}vel lesz interakciban, ha ugyanarra a {@link PalyaElem}re rkezik az {@link Ovono}.
 * Ekkor az {@link Ovono} dvzli, majd az {@link Ovoda} trli az {@link Ovodas}okat sorban, s nveli a {@link Szamlalo} rtkt (a leadott {@link Ovodas}ok szmval), ami a kzelben fog elhelyezkedni.
 *
 * @author  InFoka
 * @version %I%, %G%
 */
public class Ovoda extends KozosOs {
    public Szamlalo szamlalo;

   /**
    * A kontruktor, ami belltja a {@link Szamlalo}t.
	*/
    public Ovoda() {
		proto.Log("Ovoda::Letrehozva");
		szamlalo = proto.getSzamlalo();
    }   
	
   /**
    * Az {@link Ovono} hvja meg, amikor egy {@link PalyaElem}re kerl az {@link Ovoda}val, ekkor az {@link Ovoda} lekri az els {@link Ovodas} referencijt az {@link Ovono}tl s tadja az OvodasLancbolTorol fggvnynek.
	*
	* @param ovono	az {@link Ovono} referencija, aki idelpett
	*/
    public void OvonoUdvozol(Ovono ovono) {
		proto.Log("Ovoda::Ovono udvozolt");
		OvodasLancbolTorol(ovono.OvodasLead());
    }

   /**
    * A fggvny megkapja paramterknt az {@link Ovono} utn ll els {@link Ovodas}t, s ezutn sorra destroyolja az {@link Ovodas}okat, majd a vgn nveli a {@link Szamlalo} rtkt.
	*/
    public void OvodasLancbolTorol(Ovodas ovis) {
		proto.Log("Ovoda::Ovodas(ok) lancbol torolese");
		if(ovis!=null) {
			proto.Log("Ovoda::Ovodas(ok) lancbol torolese");
			int ovisok;
			//*** Ez a rsz arra kell, hogy gyorsan kiiktassuk az sszes vodst, hogy az vn ne tudja ket sorballtani, amikor mr igazbl Oviba kerltek. 
			Ovodas deadOne=ovis;
			for(int i=0;deadOne!=null;i++) {
				Ovodas tmpOne=(deadOne.Utana!=null?deadOne.Utana:null);
				deadOne.Allapot=4;
				deadOne=tmpOne;
			}
			//*** Ez pedig mr a tnyleges kiiktats.
			for(ovisok=0;ovis!=null;ovisok++) {
				Ovodas tmp=(ovis.Utana!=null?ovis.Utana:null);
				//ovis.Mozog(ovis.Elotte.getIranyom());
				ovis.OvodabaKerul();
				ovis=tmp;
			}
			szamlalo.EredmenytNovel(ovisok*ovisok);
		} else { proto.Log("Hiba -> Ovoda::Ovodas(ok) lancbol torolese, Nincs kit trlni"); }
    }

   /**
    * Az AktHelyzet vltozt hivatott belltani.
	*/
	public void AktHelyzetBeallit(PalyaElem akt) {
		if(akt==null) { 
			proto.Kiir("Hiba: Ovoda::AktHelyzet-et nem lehet beallitani, parameter erteke null");
			proto.Kiir("Hiba:        A teszteles idejere uj PalyaElemet hozok letre");
			AktHelyzet=new PalyaElem();
		}
		else AktHelyzet=akt;
		proto.Log("Ovoda::AktHelyzet beallitva");
		AktHelyzet.Atvesz(this);
	}
	public char getFaj() { return 'S'; }
}
