package Kindergarten;
import java.util.*;

/**
 * Az {@link Ovodas} a jtk egyik f szereplje, tbb is van belle, alapbl legalbb 16, de ez a szm vltozhat majd a ksbbi tesztek sorn.
 * Az {@link Ovono} utn llhat sorba s kvetheti, vagy egy msik {@link Ovodas} utn is llhat ha mr tbben vannak a sorban, illetve a tbbi objektummal is vannak interakcii.
 *
 * @author  InFoka
 * @version %I%, %G%
 */
public class Ovodas extends KozosOs implements Mozgat {
    public int Allapot; // 0 - mszkl, 1 - sorball, 2 - menekl, 3 - bmszkodik, 4 - ovodba kerl, 5 - lngzm
    public KozosOs Elotte;
    public Ovodas Utana;
	public static int lanyok=0;
	public static int fiuk=0;
	public int sid;
	public String nem;

   /**
    * A konstruktor, belltja az osztlyvltozkat.
	*/
	public Ovodas(String n) {
		nem=n;
		Allapot=0;
		Elotte=Utana=null;
		sid=((nem=="Fiu")?fiuk++:lanyok++); 
		gps=new GPS(this);
		proto.Log(nem+"Ovodas["+sid+"]::Letrehozva");
		start();
	}

   /**
    * Az {@link Ovono} hvja meg ezt a fggvnyt, amikor az {@link Ovodas}t belltja maga mg a sorba, ha van elg csokija az esemnyhez; ekkor tadja sajt referencijt, s az ElsoOvodas vltozjt, ami referencia az eddig mgtte llra, lehet res is.
	* Az j {@link Ovodas} mindig a sor elejre ll, gy kzli az eddigi elsvel, hogy elllt.
	*
	* @param ovono	az {@link Ovono} referencija
	* @param ovis	az {@link Ovono} mgtt ll {@link Ovodas} referencija, lehet res is
	*/
    public void SorbaAll(Ovono ovono, Ovodas ovis, int irany) {
		if(Allapot!=4) {
			if(Allapot==1) proto.Log(nem+"Ovodas["+sid+"]:: !* Mar sorba allok *!");
			else {
				proto.Log(nem+"Ovodas["+sid+"]::Sorba allok");
				Allapot=1;
				Elotte=ovono;
				Iranyom=irany;
				if(ovis!=null) { Utana=ovis; ovis.EledAllok(this); }
			}
		}
	}
    
   /**
    * Egy msik {@link Ovodas} hvja meg sajt referencijval, amely majd az aktulis {@link Ovodas} Elotte nev vltozjba kerl, tudomsul vve, hogy mr nem az {@link Ovono} ll eltte.
	*
	* @param ovis	az elll {@link Ovodas} referencija
	*/
	public void EledAllok(Ovodas ovis) {
		if(Allapot!=4) {
			String onem=ovis.getNem();
			if(onem.equals(getNem())) { 
				Elotte=ovis; proto.Log(nem+"Ovodas["+sid+"]::Elem alltak");  
		    } else { 
				proto.Log(nem+"Ovodas["+sid+"]::Elem allt egy ellenkezo nemu, ugyhogy lelepek"); 
				ovis.KilepekMoguled(); 
				Elotte=null; 
				if (Utana!=null) { 
					Utana.KilepekEloled(); 
					Utana=null; 
				}
			}
		}
	}

   /**
    * Ha a {@link Kutya} megugatja az {@link Ovodas}t akkor menekl.
	*/
    public void Menekul() {
		if(Allapot!=4) {
			proto.Log(nem+"Ovodas["+sid+"]::Menekulok");
			HagyjatokBeken();
			Allapot=2;
		}
    }
    
   /**
    * Ha a {@link Csokiautomata} vagy {@link Jatekbolt} kzelben van az {@link Ovodas}t akkor bmszkodik.
	*/
    public void Bameszkodik() {
		if(Allapot!=4) {
			proto.Log(nem+"Ovodas["+sid+"]::Bameszkodok");
			HagyjatokBeken();
			Allapot=3;
		}
    }
    
   /**
    * Az {@link Ovono} dvzli az {@link Ovodas}t ha megltja, ekkor utbbi visszakszn.
	*
	* @param ovono	az {@link Ovono} referencija
	*/
    public void OvonoUdvozol(Ovono ovono) {
		if(Allapot!=4) {
			proto.Log(nem+"Ovodas["+sid+"]::Ovono udvozolt");
			if(Allapot!=1) ovono.OvodasUdvozol(this);
		}
    }
    
   /**
    * Ha a {@link Kutya} megltja az {@link Ovodas}t ezt a fggvnyt hvja meg, amivel rveszi az {@link Ovodas}t a meneklsre.
	*/
    public void KutyaMegugat(int merrol) {
		if(Allapot!=4) {
			proto.Log(nem+"Ovodas["+sid+"]::A kutya megugatott");
			Iranyom=merrol;
			Menekul();
		}
	}

	public void HagyjatokBeken() {
		proto.Log(nem+"Ovodas["+sid+"]::Hagyjatok beken!!!");
		if(Elotte!=null) { Elotte.KilepekMoguled(); Elotte=null; }
		if(Utana!=null) { Utana.KilepekEloled(); Utana=null; }
	}

	public void KilepekEloled() {
		proto.Log(nem+"Ovodas["+sid+"]::Kileptek elolem");
		Elotte=null; 
		if(Utana!=null) { Utana.KilepekEloled(); Utana=null; }
		Allapot=0;
	}

	public void KilepekMoguled() {
		proto.Log(nem+"Ovodas["+sid+"]::Kileptek mogullem");
		Utana=null;
	}

   /**
    * Amikor az vodba kerl a lurk, akkor hvdik meg, az "eltnshez" van r szksg.
	*/
	public void OvodabaKerul() {
		Allapot=4;
		Elotte=null;
		Utana=null;
		proto.Log(nem+"Ovodas["+sid+"]::Ovodaba kerultem, ezzel vege eletemnek");
	}
    
   /**
    * A Mozgat interfsz Mozog() fggvnynek megvalstsa, a ksbbiekben lesz implementlva.
	*/
    public void Mozog(int merre) {
		//while(gps.isMoving()) { try{ sleep(40); } catch(Exception e) { return; } }
		if(Allapot!=4) {
			proto.Log(nem+"Ovodas["+sid+"]::Mozogni kezd");
			PalyaElem tmp;
			if((tmp=AktHelyzet.Atad(this,merre))!=AktHelyzet) {
				AktHelyzet=tmp;
				Vector Obj = AktHelyzet.LekerdezObjektumok();
				if(Obj!=null) for(int i=0;i<Obj.size();i++) ((KozosOs)Obj.get(i)).OvodasUdvozol(this);
				if(Utana!=null) Utana.Mozog(Iranyom);
				Iranyom=merre;
			}
			proto.Log(nem+"Ovodas["+sid+"]::Mozgast befejezi");	
		}
	}

   /**
    * Az AktHelyzet vltozt hivatott belltani.
	*/
	public void AktHelyzetBeallit(PalyaElem akt) {
		if(akt==null) { 
			proto.Kiir("Hiba: "+nem+"Ovodas["+sid+"]::AktHelyzet-et nem lehet beallitani, parameter erteke null");
			proto.Kiir("Hiba:               A teszteles idejere uj PalyaElemet hozok letre");
			AktHelyzet=new PalyaElem();
		}
		else AktHelyzet=akt;
		proto.Log(nem+"Ovodas["+sid+"]::AktHelyzet beallitva");
		AktHelyzet.Atvesz(this);
	}
	
	public void run() {
		while(true) {
			while(proto.getEnged()==false) try	{ sleep(100); }	catch (InterruptedException E){return;}
			switch(Allapot) {
				case 0: gps.SpeedWALK(); Mozog(((int) (Math.random() * (6)))); break;
				case 1: gps.SpeedFOLLOW(); break;
				case 2: gps.SpeedRUN(); Mozog(Iranyom); gps.SpeedWALK(); Allapot=0; break;
				case 3: 
				case 4: 
				default: gps.SpeedSTOP(); break;
			}
			try	{ sleep(1500); } catch (InterruptedException E){return;}
		}
	}

	public String getNem() { return nem; }

	public int getAllapot() { return Allapot; }

	public int[] Menj(int x, int y) {
		gps.setTo(x,y);
		return gps.GPSinfo();
	}
}