package Kindergarten;
import java.util.*;

/**
 * A ff osztlyunk, a legfontosabb!&nbsp;Ezt tudja irnytani a nyilakkal a felhasznl.
 *
 * @author  InFoka
 * @version %I%, %G%
 */
public class Ovono extends KozosOs implements Mozgat {
    private int CsokiSzam;
    private final int MaxCsokiSzam=5;
    private Ovodas ElsoOvodas;
	private boolean SorbaAllitasVolt;

   /**
    * A konstruktor, belltja az alap csokiszmot.
	*/
	public Ovono() {
		proto.Log("Ovono::Letrehozva");
		CsokiSzam=MaxCsokiSzam;
		SorbaAllitasVolt=false;
		gps=new GPS(this);
	}

   /**
    * A CsokiSzam vltozt cskkenti egyel.
	*/
    public void CsokiSzamCsokkent() {
		CsokiSzam--;
		proto.Log("Ovono::CsokiSzam csokkentve 1-gyel");
    }
    
   /**
    * A CsokiSzam vltozt adja vissza.
	*
	* @return	a CsokiSzam-ot adja vissza
	*/
    public int CsokiSzamLekerdez() { 
		return CsokiSzam;
    }
    
   /**
    * A csokiszmot maximlisra lltja.
	*/
    public void CsokivalFeltolt() {
		CsokiSzam=MaxCsokiSzam;
		proto.Log("Ovono::Csokival feltoltoltodtem");
    }
    
   /**
    * Az {@link Ovodas} hvja meg ezt a fggvnyt, amikor azonos {@link PalyaElem}re lp, mint ahol az {@link Ovono} tallhat (teht gy kszn egy illedelmes {@link Ovodas}).
	* Az {@link Ovono} ennek hatsra kri meg az {@link Ovodas}t hogy belljon mg a sorba, ha teljesl minden felttel ehhez.
	*
	* @param ovis	az {@link Ovodas} referencija, aki meghvja a fggvnyt
	*/
    public void OvodasUdvozol(Ovodas ovis) {
		proto.Log("Ovono::Ovodas udvozolt");
		if(CsokiSzam>0&&ovis.getAllapot()!=1) { 
			Ovodas tmp=ElsoOvodas;
			boolean mehet=true;
			while(tmp!=null) {
				if(tmp==ovis) { mehet=false; break; }
				tmp=tmp.Utana;
			}
			if(mehet) OvodasLancbaFuz(ovis); 
		}
    }
    
   /**
    * Az ElsoOvodas vltozt adja vissza az {@link Ovoda}nak, amikor vele van interakcija.
	*
	* @return az ElsoOvodas-t adja vissza
	*/
    public Ovodas OvodasLead() { 
		proto.Log("Ovono::ElsoOvodas leadasa");
		if(ElsoOvodas!=null) {
			Ovodas tmp=ElsoOvodas;
			ElsoOvodas.Mozog(Iranyom);
			ElsoOvodas=null;
			return tmp;
		} else return null;
    }
    
   /**
    * Ez a fggvny kri meg az {@link Ovodas}t, hogy lljon be a sorba.
	*
	* @param ovis	a sorbafzend {@link Ovodas} referencija
	*/
    public void OvodasLancbaFuz(Ovodas ovis) {
		proto.Log("Ovono::Ovodast sorbaallitom");
		CsokiSzamCsokkent();
		ovis.SorbaAll(this,ElsoOvodas,Iranyom);
		ElsoOvodas=ovis;
		SorbaAllitasVolt=true;
    }
    
   /**
    * A Mozgat interfsz Mozog() fggvnynek megvalstsa.
	* Az aktulis {@link PalyaElem}mel kzli hogy merre szeretne megnni, az pedig atadja a szomszdos {@link PalyaElem}nek.
	*/
    public void Mozog(int merre) {
		proto.Log("Ovono::Mozogni kezd");
		PalyaElem tmp;
		if((tmp=AktHelyzet.Atad(this,merre))!=null) {
			AktHelyzet=tmp;
			Vector Obj = AktHelyzet.LekerdezObjektumok();
			if(Obj!=null) for(int i=0;i<Obj.size();i++) ((KozosOs)Obj.get(i)).OvonoUdvozol(this);
			if(ElsoOvodas!=null && SorbaAllitasVolt==false) ElsoOvodas.Mozog(Iranyom); else { if(SorbaAllitasVolt==true) SorbaAllitasVolt=false; }
			Iranyom=merre;
		}
		proto.Log("Ovono::Mozgast befejezi");
	}

   /**
    * Az AktHelyzet vltozt hivatott belltani.
	*/
	public void AktHelyzetBeallit(PalyaElem akt) {
		if(akt==null) { 
			proto.Kiir("Hiba: Ovono::AktHelyzet-et nem lehet beallitani, parameter erteke null");
			System.exit(-1);
		}
		else AktHelyzet=akt;
		proto.Log("Ovono::AktHelyzet beallitva");
		AktHelyzet.Atvesz(this);
	}

	public void KilepekMoguled() {
		ElsoOvodas=null;
	}

	public char getFaj() { return 'O'; }

	public Ovodas getElsoOvodas() { return ElsoOvodas; }

	public int[] Menj(int x, int y) {
		gps.setTo(x,y);
		return gps.GPSinfo();
	}
}