package Kindergarten;
import java.util.*;

/**
 * A {@link Palya} fogja ltrehozni ezen objektumok sokasgt, minden ilyen ismerni fogja ngy szomszdjt.
 * Minden {@link KozosOs}bl szrmaz objektum tudni fog egy egy ilyen {@link PalyaElem}rl, amin ppen van, s azzal fog kommuniklni.
 * Ez az osztly felels azrt, hogy a rajta lv objektumok tudjanak egymssal kommuniklni, illetve Mozogni egyik {@link PalyaElem}rl a msikra.
 *
 * @author  InFoka
 * @version %I%, %G%
 */
public class PalyaElem {
    private Vector Szomszedok;
    private Vector Objektumok;
	public Proto proto;
	public static int palyaelemek=0;
	public String sid;

   /**
    * A konstruktor, csak egy j Proto objektumot hoz ltre, hogy tudjon kommuniklni a felhasznlval.
	*/
	public PalyaElem() {
		proto = new Proto();
		Szomszedok = new Vector();
		Objektumok = new Vector();
		sid=make2digit(palyaelemek++);
		proto.Log("PalyaElem["+sid+"]::Letrehozva");
	}

   /**
    * Az Atad fggvny az egyik, ami felels az objektumok mozgsrt, a mozg objektumok fogjk meghvni ezen fggvnyt, gy kzlik a {@link PalyaElem}mel, amin vannak, hogy merre szeretnnek tovbbmenni.
	* Ennek hatsra a {@link PalyaElem} felkeresi a szomszdjt s tadja a mozg objektumot, illetleg a mozg objektumnak visszaadja a szomszdja referencijt.
	*
	* @param kos	a mozg objektum referencija, amit a szomszd {@link PalyaElem}nek kell tadni
	* @param irany	az irny, amerre a mozg objektum menni kvn, a kvetkezk szerint:
	*				<ul>
	*				<li>0 - balra
	*				<li>1 - bal-fel
	*				<li>2 - jobb-fel
	*				<li>3 - jobbra
	*				<li>4 - jobb-le
	*				<li>5 - bal-le
	* @return		a megadott irnyban lv szomszd {@link PalyaElem} referencijt adja vissza
	*/
    public PalyaElem Atad(KozosOs kos, int irany) { 
		if(((PalyaElem)Szomszedok.get(irany))!=null) {
			Objektumok.remove(kos);
			((PalyaElem)Szomszedok.get(irany)).Atvesz(kos);
			return ((PalyaElem)Szomszedok.get(irany));
		} else { proto.Log("PalyaElem["+sid+"]:: !* Abban az iranyban nem mehetsz tovabb"); return this; }
    }
    
   /**
    * Az Atad fggvny prja, a vteli oldal.&nbsp;A paramterknt kapott objektumot beteszi a sajt objektumai kz (amik rajta vannak).
	*
	* @param kos	a mozg objektum referencija, amely most lpett t erre a {@link PalyaElem}re
	*/
    public void Atvesz(KozosOs kos) {
		Objektumok.add(kos);
    }
    
   /**
    * A fggvny hatsra a hv objektum megkapja, hogy milyen objektumok tartzkodnak a {@link PalyaElem}en.
	* Ezt a funkcit a mozg objektumok Mozog fggvnye fogja hvni.
	*
	* @return	a {@link PalyaElem}en tallhat Objektumokat adja vissza
	*/
    public Vector LekerdezObjektumok() { 
		//proto.Log("PalyaElem["+sid+"]::Objektumok lekerdezese");
		return Objektumok;
    }

   /**
    * A {@link PalyaElem} szomszdait lltja be.
	*
	* @param l		bal {@link PalyaElem} szomszd
	* @param lt		balfels {@link PalyaElem} szomszd
	* @param rt		jobbfels {@link PalyaElem} szomszd
	* @param r		jobb {@link PalyaElem} szomszd
	* @param rb		jobbals {@link PalyaElem} szomszd
	* @param lb		balals {@link PalyaElem} szomszd
	*/
	public void SzomszedokBeallit(PalyaElem l, PalyaElem lt, PalyaElem rt, PalyaElem r, PalyaElem rb, PalyaElem lb) {
		Szomszedok.add(l); Szomszedok.add(lt); Szomszedok.add(rt); Szomszedok.add(r); Szomszedok.add(rb); Szomszedok.add(lb);
		proto.Log("PalyaElem["+sid+"]::Szomszedok beallitva");
	}

   /**
    * Ktjegyv teszi az egyjegy szmokat is.
	*/
	public String make2digit(int x) {
		return ((x<=9)?new String("0"+x):Integer.toString(x));
	}
}